/* Zaklady programovani ... typedef, enum, struct */

#include<iostream>
#include<string>
#include "struktura.h"
using namespace std;

const std::string nazvyDnu[7] = { "pondeli","utery","streda","ctvrtek","patek","sobota","nedele" };

cislo maximum(cislo x, cislo y)
{
	if (x < y)
		return y;
	return x;
}

/* Priklady na vyctovy typ (enum) */
/* Funkce vrati true, pokud je v sobota nebo nedele. Jinak vrati false. */
bool vikend(Den den)
{
	return (den == sobota || den == nedele);
	//return (den > patek);
}

/* Funkce vypise, jaky je den v tydnu. */
void vypisDen(Den den)
{
	cout << "den je " << nazvyDnu[den]<< endl;
	/*switch (den)
	{
	case pondeli:
		cout << "dnes je pondeli";
		break;
	case utery:
		cout << "dnes je utery";
		break;
	}*/
}

/* Funkce vrati true, pokud je hodnota "kam" sever nebo jih. Jinak vrati false. */
bool muzuJit(SvetovaStrana kam)
{
	int muzuJit = sever | jih ;
	return kam & muzuJit;
//	return (kam == sever || kam == jih);
}

/* Priklad na cviceni */
void vypisZamestnance(Zamestnanec *pobocka, int n)
{
	// ...
}

int main()
{
	// Priklad: zamestnanec
	{
		Zamestnanec pepa;
		pepa.jmeno = "Josef";
		pepa.prijmeni = "Novak";
		pepa.pozice = programator;
		pepa.nastup = { 3,4,2019 };
		//pepa.nastup.den = 3;
		pepa.plat = 50000;

		Zamestnanec jana = { "Jana" , "Novotna",{1,10,2019},35000, sekretarka };

		Zamestnanec honza = pepa;
		honza.jmeno = "Jan";

		Zamestnanec pobockaPraha[3];
		pobockaPraha[0] = pepa;
		pobockaPraha[1] = jana;
		pobockaPraha[2] = honza;
		
		vypisZamestnance(pobockaPraha, 3);
	}

	/* Struktura */
	{
		Datum nekdy;                    // bez inicializace
		Datum dnes = { 25,10,2019 };    // s inicializaci
		Datum den = { 2, 1 };           // rok bude 0
		Datum terminy[5] = { {1,1,2019},{2,1,2019} }; // pole struktur, s inicializaci
 		
		nekdy = dnes;   // kopirovani struktury

		nekdy.den = 2;
		nekdy.mesic = 3;
		nekdy.rok = dnes.rok;
		nekdy.rok++;

		cout << dnes.den << '.' << dnes.mesic << '.' << dnes.rok << endl;

		Predmet matematika;
		Predmet programovani = { "Programovani",{{1,1,2019},{3,5,2019}} };
		Predmet anglictina;

		anglictina = programovani;
		anglictina.nazev = "anglictina";

		matematika.nazev = "matematika";
		matematika.terminyZkousek[0] = { 1,2,2020 };
		matematika.terminyZkousek[1].den = 2;
		matematika.terminyZkousek[1].mesic = 4;
	}

	// enum:
	{
		Den dnes = patek;
		Den vcera = ctvrtek;
		Den zitra = (Den)(dnes + 1);

		cout << patek << endl; // vypise se cislo
		switch (dnes)
		{
		case pondeli:
			cout << "dnes je pondeli";
			break;
		case utery:
			cout << "dnes je utery";
			break;
		}

		vypisDen(dnes);
		vypisDen(pondeli);

		if (vikend(zitra))
			cout << "hura!" << endl;

		SvetovaStrana kam = jih;
		if (muzuJit(kam))
			cout << "vyrazime!\n";
	}

	// typedef:
	{
		CUINt q = 7;
		cislo x = 6;
		pole a = { 1,2,3 };

		x++;
		cout << x << " " << maximum(x, 4);
	}
	return 0;
}